<?php
/*  Copyright 2004 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.

    This script defines the standard layout for PmWiki.
*/

SDV($PageSkin,'pmwiki');
SDV($PageLogoUrlFmt,'$PubDirUrl/pmwiki-32.gif');
SDV($PageCSSFmt,array('css/stdlayout.css','css/$PageSkin.css',
  'css/local.css', 'css/$Group.css', 'css/$Group.$Title_.css'));

SDVA($PageLayoutFmt,array(
  'wikilogo' => "<img src='$PageLogoUrlFmt' alt='\$WikiTitle' />",
  'wikileft' => 'wiki:Main.SideBar',
  'wikihead' => "
    <form action='\$ScriptUrl/$[Main/SearchWiki]'>
      <a href='\$ScriptUrl/$[Main/SearchWiki]'>$[SearchWiki]</a>:
      <input class='searchbox' type='text' name='text' value='' />
      <input class='searchbutton' type='submit' value='$[Go]' /></form>",
  'wikicmds' => "
    <a href='\$ScriptUrl/$[\$Group/RecentChanges]'>$[Recent Changes]</a>
    <a href='\$PageUrl?action=print'>$[Printable View]</a>
    <a href='\$PageUrl?action=diff'>$[Page History]</a>
    <a href='\$PageUrl?action=edit'>$[Edit Page]</a>",
  'wikititle' => "
    <div class='pagegroup'><a href='\$ScriptUrl/\$Group'>\$Group</a> /</div>
    <div class='pagetitle'><a href='\$PageUrl?action=search&amp;text=\$Title_'>\$Title</a></div>",
  'wikifoot' => "
    <div class='footnav'>
      <a href='\$PageUrl?action=edit'>$[Edit Page]</a> -
      <a href='\$PageUrl?action=diff'>$[Page History]</a> -
      <a href='\$PageUrl?action=print'>$[Printable View]</a> -
      <a href='\$ScriptUrl/$[\$Group/RecentChanges]'>$[Recent Changes]</a> - 
      <a href='\$ScriptUrl/$[PmWiki/WikiHelp]'>$[WikiHelp]</a> -
      <a href='\$ScriptUrl/$[Main/SearchWiki]'>$[SearchWiki]</a></div>
    <div class='lastmod'>
      $[Page last modified on \$LastModified]</div>"));
SDVA($PageDivs,array(
  'PageHeaderFmt' => array('wikilogo','wikihead','wikileft'),
  'PageTitleFmt' => array('wikititle','wikicmds'),
  'PageFooterFmt' => 'wikifoot'));

$HTMLHeaderFmt = (array)$HTMLHeaderFmt;
foreach($PageCSSFmt as $k) {
  $c = FmtPageName($k,$pagename);
  if (file_exists("pub/$c")) $HTMLHeaderFmt[] = 
    "  <link rel='stylesheet' href='\$PubDirUrl/$c' type='text/css' />\n";
}

foreach ($PageDivs as $k=>$d) {
  $$k = array();
  foreach((array)$d as $v) 
    array_push($$k,"\n  <div id='$v'>",&$PageLayoutFmt[$v],"</div>");
}

SDV($PageEditFmt,"
  <div id='wikiedit'>
  <a id='top' name='top'></a><h1 class='wikiaction'1>Editing \$PageName</h1>
  <form action='\$PageUrl' method='post'>
  <input type='hidden' name='pagename' value='\$PageName' />
  <input type='hidden' name='action' value='edit' />
  <textarea name='text' rows='25' cols='60'
    onkeydown='if (event.keyCode == 27) event.returnValue=false;'
    >\$Text</textarea><br />
  $[Author]: <input type='text' name='author' value='\$Author' />
  <input type='checkbox' name='diffclass' value='minor'>
    $[This is a minor edit]<br />
  <input type='submit' name='post' value=' $[Save] ' />
  <input type='submit' name='preview' value=' $[Preview] ' />
  <input type='reset' value=' $[Reset] ' />
  </form></div>");
SDV($PagePreviewFmt,array(
  "function:ProcessTextDirectives",
  "<h2>Preview \$PageName</h2><b>Page is unsaved</b><hr /><p />",
  "function:PrintText",
  "<hr /><b>End of preview -- remember to save</b>
   <br /><a href='#top'>$[Top]</a>"));

SDV($PageAttrFmt,"<h1 class='wikiaction'>$[\$PageName Attributes]</h1>
  <p>Enter new attributes for this page below.  Leaving a field blank
  will leave the attribute unchanged.  To clear an attribute, enter
  'clear'.</p>");

SDV($HandleBrowseFmt,array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  "\n  <div id='wikitext'>",&$PageRedirectFmt,'function:PrintText','</div>',
  &$PageFooterFmt,&$HTMLEndFmt));
SDV($HandleEditFmt,array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  "\n  <div id='wikitext'>",&$PageEditFmt,'wiki:$[PmWiki.EditQuickReference]',
  &$PagePreviewFmt,'</div>',&$PageFooterFmt,&$HTMLEndFmt));
SDV($HandleAttrFmt,array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  "\n  <div id='wikitext'>",&$PageAttrFmt,'function:PrintAttrForm','</div>',
  &$PageFooterFmt,&$HTMLEndFmt));
?>
